import argparse, pandas, sys

def get_set(i, o, Bin):

    hmp= pandas.read_table(i)

    binned= hmp.groupby(['chrom', (hmp['pos']//Bin)])
    outframe= hmp.ix[[group['read_num'].idxmax() for group_val, group in binned]]
    outframe.to_csv(o, sep= '\t', index=False, na_rep="NA")

def main():

    parser= argparse.ArgumentParser(description= "PLUMAGE v. 2.0: pipeline for GBS error correction")

    parser.add_argument('-i', metavar= 'infile', nargs='?', type= argparse.FileType('r'), default= sys.stdin,
                        help= "path/name for data file containing a column with read numbers"+
                        " to choose a subset of snps from, default= stdin")

    parser.add_argument('-o', metavar= 'outfile', required= True,
                        help= "path/name for resulting subset")

    parser.add_argument('-b', metavar= 'bin_size', default= 240000, type=int,
                         help= "bin size in base pairs -- i.e. number of base pairs"+
                         " you want between snps, default = 240000")

    args = parser.parse_args()
    get_set(args.i, args.o, args.b)

    print("Plumage 6 is finished", file=sys.stderr)

if __name__ == "__main__":
  main()
